<?php
/**********************************************************************
    Copyright (C) FrontAccounting, LLC.
	Released under the terms of the GNU General Public License, GPL, 
	as published by the Free Software Foundation, either version 3 
	of the License, or (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
    See the License here <http://www.gnu.org/licenses/gpl-3.0.html>.
***********************************************************************/
//--------------------------------------------------------------------------------

// Base function for adding a GL transaction
// $date_ is display date (non-sql)
// $amount is in $currency currency
// if $currency is not set, then defaults to no conversion

function add_marketing_trans($ref,$marketing_type,$marketing_place,$marketing_address,$marketing_name,$marketing_position,$marketing_company,$marketing_bussiness,$npwp,$bpotong,$sklien,$invoice,$ssyai,$amount=0,$baris=0,$id='')
{
	global $SysPrefs;
	/*
	$sql = "INSERT INTO ".TB_PREF."marketing_trans ( ref,marketing_type,marketing_place,marketing_address,marketing_name,marketing_position,marketing_company,marketing_bussiness";
	$sql .= ") ";

	$sql .= "VALUES (".db_escape($ref).", ".db_escape($marketing_type).", ".db_escape($marketing_place).", ".db_escape($marketing_address).", ".db_escape($marketing_name).", ".db_escape($marketing_position).", ".db_escape($marketing_company).", ".db_escape($marketing_bussiness).")";
	*/
	if($id==''){
		$sql="INSERT INTO `".TB_PREF."marketing_trans` 
			(`id`, `ref`, `marketing_type`, `marketing_place`, `marketing_address`, `marketing_name`, `marketing_position`, `marketing_company`, `marketing_business`, `npwp`, `bpotong`, `sklien`, `invoice`, `ssyai`, `amount`, `line`) 
			VALUES (NULL, ".db_escape(@$ref).", 
			".db_escape(@$marketing_type).", 
			".db_escape(@$marketing_place).", 
			".db_escape(@$marketing_address).", 
			".db_escape(@$marketing_name).", 
			".db_escape(@$marketing_position).", 
			".db_escape(@$marketing_company).", 
			".db_escape(@$marketing_bussiness).", 
			".db_escape(@$npwp).", 
			".db_escape(@$bpotong).", 
			".db_escape(@$sklien).", 
			".db_escape(@$invoice).", 
			".db_escape(@$ssyai).", 
			".db_escape(@$amount).", 
			".db_escape(@$baris).")";
	}else{
		$sql="UPDATE `0_marketing_trans` SET `marketing_type` = ".db_escape(@$marketing_type).", `marketing_place` = ".db_escape(@$marketing_place).", `marketing_address` = ".db_escape(@$marketing_address).", `marketing_name` = ".db_escape(@$marketing_name).", `marketing_position` = ".db_escape(@$marketing_position).", `marketing_company` = ".db_escape(@$marketing_company).", `marketing_business` = ".db_escape(@$marketing_bussiness).", `npwp` = ".db_escape(@$npwp).", `bpotong` = ".db_escape(@$bpotong).", `sklien` = ".db_escape(@$sklien).", `invoice` = ".db_escape(@$invoice).", `ssyai` = ".db_escape(@$ssyai).", `amount` = ".db_escape(@$amount).", `line` = ".db_escape(@$baris)." WHERE `0_marketing_trans`.`id` = ".db_escape(@$id).";";
	}

	$err_msg = "The marketing transaction could not be inserted";
	//printf($sql);
	//die;
	//return $sql;
	return db_query($sql, $err_msg);
}

function add_gl_trans($type, $trans_id, $date_, $account, $dimension, $dimension2, $memo_,
	$amount, $currency=null, $person_type_id=null, $person_id=null,	$err_msg="", $rate=0, $stock_id=null, $jasa=null)
{
	global $SysPrefs;

	$date = date2sql($date_);
	if ($currency != null)
	{
		if ($rate == 0){
			//	1-1703   2-1401 2-2101 6-9004 6-9103 6-9900 6-9990
			if($account=='11703' or $account=='12301' or $account=='21240' or $account=='21401' or $account=='22101' or $account=='69004' or $account=='69103'or $account=='69900'or $account=='69990')
			//$amount_in_home_currency = to_home_currency_tax($amount, $currency, $date_);
			$amount_in_home_currency = round2($amount * 1,  user_price_dec());
			else
			//$amount_in_home_currency = to_home_currency($amount, $currency, $date_);
			$amount_in_home_currency = round2($amount * 1,  user_price_dec());
		}
		else{
			$amount_in_home_currency = round2($amount * $rate,  user_price_dec());
			//$amount_in_home_currency = round2($amount * 1,  user_price_dec());

		}
	}		
	else
		$amount_in_home_currency = $amount;
	if ($dimension == null || $dimension < 0)
		$dimension = 0;
	if ($dimension2 == null || $dimension2 < 0)
		$dimension2 = 0;
	if (isset($SysPrefs->use_audit_trail) && $SysPrefs->use_audit_trail)
	{
		if ($memo_ == "" || $memo_ == null)
			$memo_ = $_SESSION["wa_current_user"]->username;
		else
			$memo_ = $_SESSION["wa_current_user"]->username . " - " . $memo_;
	}
	if (!is_subledger_account($account) || $account==get_company_pref('grn_clearing_act'))
		$person_id = $person_type_id = null;
	
	$sql = "INSERT INTO ".TB_PREF."gl_trans ( type, type_no, tran_date,
		account, dimension_id, dimension2_id, memo_, amount";

	if ($person_type_id != null)
		$sql .= ", person_type_id, person_id";

	$sql .= ", jasa";
	$sql .= ") ";

	$sql .= "VALUES (".db_escape($type).", ".db_escape($trans_id).", '$date',
		".db_escape($account).", ".db_escape($dimension).", "
		.db_escape($dimension2).", ".db_escape($memo_).", "
		.db_escape($amount_in_home_currency);

	if ($person_type_id != null)
		$sql .= ", ".db_escape($person_type_id).", ". db_escape($person_id);
	
	$sql .= ", ". db_escape($jasa);

	$sql .= ") ";
	if ($err_msg == "")
		$err_msg = "The GL transaction could not be inserted";
		//echo $sql;
	db_query($sql, $err_msg);

	if($account=='11699' && $stock_id!=null && $amount<0){
		/*$sql = "SELECT SUM(amount)
		FROM ".TB_PREF."gl_trans
		WHERE account=".db_escape($account)
			." AND type=".db_escape($type)
			." AND type_no=".db_escape($trans_no);

		$result = db_query($sql, "query for gl trans value");

		$row = db_fetch_row($result);
		*/

		$sql2="INSERT INTO ".TB_PREF."stock_moves (`trans_id`, `trans_no`, `stock_id`, `type`, `loc_code`, `tran_date`, `price`, `reference`, `qty`, `standard_cost`) VALUES (NULL, '0', ".db_escape($stock_id).", '25', 'DEF', ".db_escape($date).",".db_escape(($amount*(-1))).", ".db_escape(@$ref).", '1', '0');";
		$result=db_query($sql2, '');
	}

	return $amount_in_home_currency;
}

//--------------------------------------------------------------------------------

// GL Trans for standard costing, always home currency regardless of person
// $date_ is display date (non-sql)
// $amount is in HOME currency

function add_gl_trans_std_cost($type, $trans_id, $date_, $account, $dimension, $dimension2,
	$memo_,	$amount, $person_type_id=null, $person_id=null, $err_msg="")
{

	if ($amount != 0)
		return add_gl_trans($type, $trans_id, $date_, $account, $dimension, $dimension2, $memo_,
			$amount, null, $person_type_id, $person_id, $err_msg);
	else
		return 0;
}

// Function for even out rounding problems
function add_gl_balance($type, $trans_id, $date_, $amount, $person_type_id=null, $person_id=null)
{
	$amount = round2($amount, user_price_dec());

	if (floatcmp($amount, 0))
	{
		error_log(sprintf( _("Rounding error %s encountered for trans_type:%s,trans_no:%s"), $amount, $type, $trans_id));
		return add_gl_trans($type, $trans_id, $date_, get_company_pref('exchange_diff_act'), 0, 0, "",
			$amount, null, $person_type_id, $person_id, "The balanced GL transaction could not be inserted");
	} else
		return 0;
}

//--------------------------------------------------------------------------------

function get_all_coa($account=null)
{
	global $SysPrefs;

	$sql = "SELECT account_code,account_code2,account_name FROM ".TB_PREF."chart_master ";

	if ($account != null)
		$sql .= " where account_code = ".db_escape($account);

	return db_query($sql, "The transactions for could not be retrieved");
}

function get_all_coa2($account=null)
{
	global $SysPrefs;

	$sql = "SELECT account_code,account_code2,account_name FROM ".TB_PREF."chart_master ";

	if ($account != null)
		$sql .= " where account_code in ".($account);

	return db_query($sql, "The transactions for could not be retrieved");
}

function get_gl_transactions($from_date, $to_date, $trans_no=0,
	$account=null, $dimension=0, $dimension2=0, $filter_type=null,
	$amount_min=null, $amount_max=null, $person_id=null)
{
	global $SysPrefs;

	$from = date2sql($from_date);
	$to = date2sql($to_date);

	$sql = "SELECT gl.*, j.event_date, j.doc_date, a.gl_seq, u.user_id, st.supp_reference, gl.person_id subcode,
			IFNULL(IFNULL(sup.supp_name, debt.name), bt.person_id) as person_name, 
			IFNULL(gl.person_id, IFNULL(sup.supplier_id, debt.debtor_no)) as person_id,
			IFNULL(st.tran_date, IFNULL(dt.tran_date, IFNULL(bt.trans_date, IFNULL(grn.delivery_date, gl.tran_date)))) as doc_date,
			coa.account_code2,coa.account_name, ref.reference
			 FROM "
			.TB_PREF."gl_trans gl
			LEFT JOIN ".TB_PREF."voided v ON gl.type_no=v.id AND v.type=gl.type

			LEFT JOIN ".TB_PREF."supp_trans st ON gl.type_no=st.trans_no AND st.type=gl.type AND (gl.type!=".ST_JOURNAL." OR gl.person_id=st.supplier_id)
			LEFT JOIN ".TB_PREF."grn_batch grn ON grn.id=gl.type_no AND gl.type=".ST_SUPPRECEIVE." AND gl.person_id=grn.supplier_id
			LEFT JOIN ".TB_PREF."debtor_trans dt ON gl.type_no=dt.trans_no AND dt.type=gl.type AND (gl.type!=".ST_JOURNAL." OR gl.person_id=dt.debtor_no)

			LEFT JOIN ".TB_PREF."suppliers sup ON st.supplier_id=sup.supplier_id OR grn.supplier_id=sup.supplier_id
			LEFT JOIN ".TB_PREF."cust_branch branch ON dt.branch_code=branch.branch_code
			LEFT JOIN ".TB_PREF."debtors_master debt ON dt.debtor_no=debt.debtor_no

			LEFT JOIN ".TB_PREF."bank_trans bt ON bt.type=gl.type AND bt.trans_no=gl.type_no AND bt.amount!=0
				 AND bt.person_type_id=gl.person_type_id AND bt.person_id=gl.person_id

			left JOIN ".TB_PREF."journal j ON j.type=gl.type AND j.trans_no=gl.type_no AND j.posting=0 
			LEFT JOIN ".TB_PREF."audit_trail a ON a.type=gl.type AND a.trans_no=gl.type_no AND NOT ISNULL(gl_seq)
			LEFT JOIN ".TB_PREF."users u ON a.user=u.id

			LEFT JOIN ".TB_PREF."refs ref ON ref.type=gl.type AND ref.id=gl.type_no,"
		.TB_PREF."chart_master coa
		WHERE coa.account_code=gl.account
		AND ISNULL(v.date_)
		AND gl.tran_date >= '$from'
		AND gl.tran_date <= '$to'";
	if (isset($SysPrefs->show_voided_gl_trans) && $SysPrefs->show_voided_gl_trans == 0)
		$sql .= " AND gl.amount <> 0"; 

	if ($person_id)
		$sql .= " AND gl.person_id=".db_escape($person_id); 

	if ($trans_no > 0)
		$sql .= " AND gl.type_no LIKE ".db_escape('%'.$trans_no);;

	if ($account != null)
		$sql .= " AND gl.account like '".$account."%' ";

	if ($dimension > 0)
		$sql .= " AND gl.dimension_id = ".($dimension<0 ? 0 : db_escape($dimension));

	if ($dimension2 > 0)
		$sql .= " AND gl.dimension2_id = ".($dimension2<0 ? 0 : db_escape($dimension2));

	if ($filter_type != null AND is_numeric($filter_type))
		$sql .= " AND gl.type= ".db_escape($filter_type);

	if ($amount_min != null)
		$sql .= " AND ABS(gl.amount) >= ABS(".db_escape($amount_min).")";
	
	if ($amount_max != null)
		$sql .= " AND ABS(gl.amount) <= ABS(".db_escape($amount_max).")";
	
	//return $sql .= " ORDER BY tran_date,reference, amount desc";

	return db_query($sql, "The transactions for could not be retrieved");
}


function get_gl_transactions2($from_date, $to_date, $trans_no=0,
	$account=null, $dimension=0, $dimension2=0, $filter_type=null,
	$amount_min=null, $amount_max=null, $person_id=null)
{
	global $SysPrefs;

	$from = date2sql($from_date);
	$to = date2sql($to_date);

	$sql = "SELECT gl.*, j.event_date, j.doc_date, a.gl_seq, u.user_id, st.supp_reference, gl.person_id subcode,
			IFNULL(IFNULL(sup.supp_name, debt.name), bt.person_id) as person_name, 
			IFNULL(gl.person_id, IFNULL(sup.supplier_id, debt.debtor_no)) as person_id,
			IFNULL(st.tran_date, IFNULL(dt.tran_date, IFNULL(bt.trans_date, IFNULL(grn.delivery_date, gl.tran_date)))) as doc_date,
			coa.account_code2,coa.account_name, ref.reference
			 FROM "
			.TB_PREF."gl_trans gl
			LEFT JOIN ".TB_PREF."voided v ON gl.type_no=v.id AND v.type=gl.type

			LEFT JOIN ".TB_PREF."supp_trans st ON gl.type_no=st.trans_no AND st.type=gl.type AND (gl.type!=".ST_JOURNAL." OR gl.person_id=st.supplier_id)
			LEFT JOIN ".TB_PREF."grn_batch grn ON grn.id=gl.type_no AND gl.type=".ST_SUPPRECEIVE." AND gl.person_id=grn.supplier_id
			LEFT JOIN ".TB_PREF."debtor_trans dt ON gl.type_no=dt.trans_no AND dt.type=gl.type AND (gl.type!=".ST_JOURNAL." OR gl.person_id=dt.debtor_no)

			LEFT JOIN ".TB_PREF."suppliers sup ON st.supplier_id=sup.supplier_id OR grn.supplier_id=sup.supplier_id
			LEFT JOIN ".TB_PREF."cust_branch branch ON dt.branch_code=branch.branch_code
			LEFT JOIN ".TB_PREF."debtors_master debt ON dt.debtor_no=debt.debtor_no

			LEFT JOIN ".TB_PREF."bank_trans bt ON bt.type=gl.type AND bt.trans_no=gl.type_no AND bt.amount!=0
				 AND bt.person_type_id=gl.person_type_id AND bt.person_id=gl.person_id

			left JOIN ".TB_PREF."journal j ON j.type=gl.type AND j.trans_no=gl.type_no AND j.posting=0 
			LEFT JOIN ".TB_PREF."audit_trail a ON a.type=gl.type AND a.trans_no=gl.type_no AND NOT ISNULL(gl_seq)
			LEFT JOIN ".TB_PREF."users u ON a.user=u.id

			LEFT JOIN ".TB_PREF."refs ref ON ref.type=gl.type AND ref.id=gl.type_no,"
		.TB_PREF."chart_master coa
		WHERE coa.account_code=gl.account 
		AND ISNULL(v.date_)
		AND gl.tran_date >= '$from'
		AND gl.tran_date <= '$to'";
	if (isset($SysPrefs->show_voided_gl_trans) && $SysPrefs->show_voided_gl_trans == 0)
		$sql .= " AND gl.amount <> 0"; 

	if ($person_id)
		$sql .= " AND gl.person_id=".db_escape($person_id); 

	if ($trans_no > 0)
		$sql .= " AND gl.type_no LIKE ".db_escape('%'.$trans_no);;

	if ($account != null)
		$sql .= " AND gl.account like '".$account."%' ";

	if ($dimension > 0)
		$sql .= " AND gl.dimension_id = ".($dimension<0 ? 0 : db_escape($dimension));

	if ($dimension2 > 0)
		$sql .= " AND gl.dimension2_id = ".($dimension2<0 ? 0 : db_escape($dimension2));

	if ($filter_type != null AND is_numeric($filter_type))
		$sql .= " AND gl.type= ".db_escape($filter_type);

	if ($amount_min != null)
		$sql .= " AND ABS(gl.amount) >= ABS(".db_escape($amount_min).")";
	
	if ($amount_max != null)
		$sql .= " AND ABS(gl.amount) <= ABS(".db_escape($amount_max).")";
	
	$sql .= " ORDER BY tran_date,reference, amount desc";

	return db_query($sql, "The transactions for could not be retrieved");
}

function get_gl_transactions_export($from_date, $to_date)
{
	global $SysPrefs;

	$from = date2sql($from_date);
	$to = date2sql($to_date);

	$sql = "select a.*,b.reference,d.account_code,d.account_code2,d.account_name
from 0_gl_trans a 
inner join 0_refs b on a.type_no=b.id and a.type=b.type
inner join 0_chart_master d on a.account=d.account_code
left join 0_voided c on a.type_no=c.id and a.type=c.type
where a.tran_date BETWEEN '$from' and '$to'
and c.id is null
ORDER BY a.tran_date,b.reference, a.amount asc";

	return db_query($sql, "The transactions for could not be retrieved");
}

function get_gl_transactions_export_rec($from_date, $to_date)
{
	global $SysPrefs;

	$from = date2sql($from_date);
	$to = date2sql($to_date);

	$sql = "select a.*,b.reference,d.account_code,d.account_code2,d.account_name
from 0_gl_trans a 
inner join 0_refs b on a.type_no=b.id and a.type=b.type
inner join 0_chart_master d on a.account=d.account_code
left join 0_voided c on a.type_no=c.id and a.type=c.type
where a.tran_date BETWEEN '$from' and '$to'
and c.id is null
ORDER BY a.tran_date,b.reference, a.amount desc";

	return db_query($sql, "The transactions for could not be retrieved");
}

function get_gl_memo($type_no, $type,$baris)
{
	global $SysPrefs;

	$from = date2sql($from_date);
	$to = date2sql($to_date);

	$sql = "select memo_
from 0_gl_trans a 
where a.type_no=$type_no and a.type=$type and a.memo_ like '%$baris%' ";

	$result=db_query($sql, "The transactions for could not be retrieved");
	$row = db_fetch_row($result);
	return $row[0];
}
function get_gl_memo2($type_no, $type)
{
	global $SysPrefs;

	//$from = date2sql($from_date);
	//$to = date2sql($to_date);

	$sql = "select amount,memo_
from 0_gl_trans a 
inner join 0_chart_master d on a.account=d.account_code
where a.type_no=$type_no and a.type=$type and d.account_type in ('1-1100','1-1150') ";

	$result=db_query($sql, "The transactions for could not be retrieved");
	$row = db_fetch_row($result);
	return array($row[0],$row[1]);
}
function get_gl_memo_mfee($type_no, $type)
{
	global $SysPrefs;

	//$from = date2sql($from_date);
	//$to = date2sql($to_date);

	$sql = "select amount,memo_
from 0_gl_trans a 
inner join 0_chart_master d on a.account=d.account_code
where a.type_no=$type_no and a.type=$type and a.account like '11401' ";

	$result=db_query($sql, "The transactions for could not be retrieved");
	$row = db_fetch_row($result);
	return array($row[0],$row[1]);
}
function get_gl_transactions_marketing2($from_date, $to_date, $trans_no=0,
	$account=null, $dimension=0, $dimension2=0, $filter_type=null,
	$amount_min=null, $amount_max=null, $person_id=null)
{
	global $SysPrefs;

	$from = date2sql($from_date);
	$to = date2sql($to_date);

	$sql = "select gl.tran_date,gl.amount as gl_amount,gl.memo_,gl.type,gl.type_no,c.* from ".TB_PREF."gl_trans gl 
	left join ".TB_PREF."refs b on b.id=gl.type_no and b.type=gl.type 
	left join ".TB_PREF."marketing_trans c on c.ref=b.reference  and c.amount=gl.amount 
	left join 0_voided d on gl.type_no=d.id and gl.type=d.type
	where gl.account like '62002%'
		AND gl.tran_date >= '$from'
		AND gl.tran_date <= '$to'
		AND d.id is null ";
	if (isset($SysPrefs->show_voided_gl_trans) && $SysPrefs->show_voided_gl_trans == 0)
		$sql .= " AND gl.amount <> 0"; 

	if ($person_id)
		$sql .= " AND gl.person_id=".db_escape($person_id); 

	if ($trans_no > 0)
		$sql .= " AND gl.type_no LIKE ".db_escape('%'.$trans_no);

	if ($account != null)
		$sql .= " AND gl.account = ".db_escape($account);

	if ($dimension > 0)
		$sql .= " AND gl.dimension_id = ".($dimension<0 ? 0 : db_escape($dimension));

	if ($dimension2 > 0)
		$sql .= " AND gl.dimension2_id = ".($dimension2<0 ? 0 : db_escape($dimension2));

	if ($filter_type != null AND is_numeric($filter_type))
		$sql .= " AND gl.type= ".db_escape($filter_type);

	if ($amount_min != null)
		$sql .= " AND ABS(gl.amount) >= ABS(".db_escape($amount_min).")";
	
	if ($amount_max != null)
		$sql .= " AND ABS(gl.amount) <= ABS(".db_escape($amount_max).")";
	
	$sql .= " group by c.ref,c.id ORDER BY tran_date, counter";

	return db_query($sql, "The transactions for could not be retrieved");
}

function get_gl_transactions_marketing($from_date, $to_date, $trans_no=0,
	$account=null, $dimension=0, $dimension2=0, $filter_type=null,
	$amount_min=null, $amount_max=null, $person_id=null)
{
	global $SysPrefs;

	$from = date2sql($from_date);
	$to = date2sql($to_date);
	//gl.account in ('62003','62004','62003001','62003002','62003003','62003004')
	$sql = "select gl.tran_date,gl.amount as gl_amount,gl.memo_,gl.type,gl.type_no,c.*,b.reference from ".TB_PREF."gl_trans gl 
	left join ".TB_PREF."refs b on b.id=gl.type_no and b.type=gl.type 
	left join ".TB_PREF."marketing_trans c on c.ref=b.reference and c.amount=gl.amount 
	left join 0_voided d on gl.type_no=d.id and gl.type=d.type
	where (gl.account like '62003%' or  gl.account like '62004%' )
		AND gl.tran_date >= '$from'
		AND gl.tran_date <= '$to'
		AND d.id IS NULL ";
	if (isset($SysPrefs->show_voided_gl_trans) && $SysPrefs->show_voided_gl_trans == 0)
		$sql .= " AND gl.amount <> 0"; 

	if ($person_id)
		$sql .= " AND gl.person_id=".db_escape($person_id); 

	if ($trans_no > 0)
		$sql .= " AND gl.type_no LIKE ".db_escape('%'.$trans_no);

	if ($account != null)
		$sql .= " AND gl.account = ".db_escape($account);

	if ($dimension > 0)
		$sql .= " AND gl.dimension_id = ".($dimension<0 ? 0 : db_escape($dimension));

	if ($dimension2 > 0)
		$sql .= " AND gl.dimension2_id = ".($dimension2<0 ? 0 : db_escape($dimension2));

	if ($filter_type != null AND is_numeric($filter_type))
		$sql .= " AND gl.type= ".db_escape($filter_type);

	if ($amount_min != null)
		$sql .= " AND ABS(gl.amount) >= ABS(".db_escape($amount_min).")";
	
	if ($amount_max != null)
		$sql .= " AND ABS(gl.amount) <= ABS(".db_escape($amount_max).")";
	
	$sql .= " ORDER BY tran_date, counter";

	return db_query($sql, "The transactions for could not be retrieved");
}

function get_gl_transactions_sponsor($from_date, $to_date, $trans_no=0,
	$account=null, $dimension=0, $dimension2=0, $filter_type=null,
	$amount_min=null, $amount_max=null, $person_id=null)
{
	global $SysPrefs;

	$from = date2sql($from_date);
	$to = date2sql($to_date);

	$sql = "select gl.tran_date,gl.amount as gl_amount,gl.memo_,gl.type,gl.type_no,c.* from ".TB_PREF."gl_trans gl 
	inner join ".TB_PREF."refs b on b.id=gl.type_no and b.type=gl.type 
	inner join ".TB_PREF."marketing_trans c on c.ref=b.reference and c.amount=gl.amount 
	left join 0_voided d on gl.type_no=d.id and gl.type=d.type
	where gl.account like '62001%'
		AND gl.tran_date >= '$from'
		AND gl.tran_date <= '$to'
		AND d.id is null ";
	if (isset($SysPrefs->show_voided_gl_trans) && $SysPrefs->show_voided_gl_trans == 0)
		$sql .= " AND gl.amount <> 0"; 

	if ($person_id)
		$sql .= " AND gl.person_id=".db_escape($person_id); 

	if ($trans_no > 0)
		$sql .= " AND gl.type_no LIKE ".db_escape('%'.$trans_no);

	if ($account != null)
		$sql .= " AND gl.account = ".db_escape($account);

	if ($dimension > 0)
		$sql .= " AND gl.dimension_id = ".($dimension<0 ? 0 : db_escape($dimension));

	if ($dimension2 > 0)
		$sql .= " AND gl.dimension2_id = ".($dimension2<0 ? 0 : db_escape($dimension2));

	if ($filter_type != null AND is_numeric($filter_type))
		$sql .= " AND gl.type= ".db_escape($filter_type);

	if ($amount_min != null)
		$sql .= " AND ABS(gl.amount) >= ABS(".db_escape($amount_min).")";
	
	if ($amount_max != null)
		$sql .= " AND ABS(gl.amount) <= ABS(".db_escape($amount_max).")";
	
	$sql .= " ORDER BY tran_date, counter";

	return db_query($sql, "The transactions for could not be retrieved");
}
//--------------------------------------------------------------------------------

function get_gl_trans($type, $trans_id)
{
	$sql = "SELECT gl.*,cm.account_code2 as account2, cm.account_name, IFNULL(refs.reference, '') AS reference, user.real_name, 
			COALESCE(st.tran_date, dt.tran_date, bt.trans_date, grn.delivery_date, gl.tran_date) as doc_date,
			IF(ISNULL(st.supp_reference), '', st.supp_reference) AS supp_reference
			
	FROM ".TB_PREF."gl_trans as gl
		LEFT JOIN ".TB_PREF."chart_master as cm ON gl.account = cm.account_code
		LEFT JOIN ".TB_PREF."refs as refs ON (gl.type=refs.type AND gl.type_no=refs.id)
		LEFT JOIN ".TB_PREF."audit_trail as audit ON (gl.type=audit.type AND gl.type_no=audit.trans_no AND NOT ISNULL(gl_seq))
		LEFT JOIN ".TB_PREF."users as user ON (audit.user=user.id)
		LEFT JOIN ".TB_PREF."supp_trans st ON gl.type_no=st.trans_no AND st.type=gl.type AND (gl.type!=".ST_JOURNAL." OR gl.person_id=st.supplier_id)
		LEFT JOIN ".TB_PREF."grn_batch grn ON grn.id=gl.type_no AND gl.type=".ST_SUPPRECEIVE." AND gl.person_id=grn.supplier_id
		LEFT JOIN ".TB_PREF."debtor_trans dt ON gl.type_no=dt.trans_no AND dt.type=gl.type AND (gl.type!=".ST_JOURNAL." OR gl.person_id=dt.debtor_no)
		LEFT JOIN ".TB_PREF."bank_trans bt ON bt.type=gl.type AND bt.trans_no=gl.type_no AND bt.amount!=0
			 AND bt.person_type_id=gl.person_type_id AND bt.person_id=gl.person_id
		LEFT JOIN ".TB_PREF."journal j ON j.type=gl.type AND j.trans_no=gl.type_no"

		." WHERE gl.type= ".db_escape($type) 
		." AND gl.type_no = ".db_escape($trans_id)
		." AND gl.amount <> 0"
		." ORDER BY counter, amount asc";

	return db_query($sql, "The gl transactions could not be retrieved");
}

function get_gl_trans_vc($type, $trans_id)
{
	$sql = "SELECT gl.*,cm.account_code2 as account2, cm.account_name, IFNULL(refs.reference, '') AS reference, user.real_name, 
			COALESCE(st.tran_date, dt.tran_date, bt.trans_date, grn.delivery_date, gl.tran_date) as doc_date,
			IF(ISNULL(st.supp_reference), '', st.supp_reference) AS supp_reference
	FROM ".TB_PREF."gl_trans as gl
		LEFT JOIN ".TB_PREF."chart_master as cm ON gl.account = cm.account_code
		LEFT JOIN ".TB_PREF."refs as refs ON (gl.type=refs.type AND gl.type_no=refs.id)
		LEFT JOIN ".TB_PREF."audit_trail as audit ON (gl.type=audit.type AND gl.type_no=audit.trans_no AND NOT ISNULL(gl_seq))
		LEFT JOIN ".TB_PREF."users as user ON (audit.user=user.id)
	# all this below just to retrieve doc_date :>
		LEFT JOIN ".TB_PREF."supp_trans st ON gl.type_no=st.trans_no AND st.type=gl.type AND (gl.type!=".ST_JOURNAL." OR gl.person_id=st.supplier_id)
		LEFT JOIN ".TB_PREF."grn_batch grn ON grn.id=gl.type_no AND gl.type=".ST_SUPPRECEIVE." AND gl.person_id=grn.supplier_id
		LEFT JOIN ".TB_PREF."debtor_trans dt ON gl.type_no=dt.trans_no AND dt.type=gl.type AND (gl.type!=".ST_JOURNAL." OR gl.person_id=dt.debtor_no)
		LEFT JOIN ".TB_PREF."bank_trans bt ON bt.type=gl.type AND bt.trans_no=gl.type_no AND bt.amount!=0
			 AND bt.person_type_id=gl.person_type_id AND bt.person_id=gl.person_id
		LEFT JOIN ".TB_PREF."journal j ON j.type=gl.type AND j.trans_no=gl.type_no"

		." WHERE gl.type= ".db_escape($type) 
		." AND gl.type_no = ".db_escape($trans_id)
		//." AND gl.amount > 0"
		//." AND cm.account_type not in ('1-1150')"
		." ORDER BY tran_date,counter, amount desc";
		//." AND gl.amount <> 0"

	return db_query($sql, "The gl transactions could not be retrieved");
}


function get_gl_trans2($type, $trans_id)
{
	$sql = "SELECT gl.*, cm.account_code2 as account2, cm.account_name, IFNULL(refs.reference, '') AS reference, user.real_name, 
			COALESCE(st.tran_date, dt.tran_date, bt.trans_date, grn.delivery_date, gl.tran_date) as doc_date,
			IF(ISNULL(st.supp_reference), '', st.supp_reference) AS supp_reference,
			i.bank_name as bank_name,i.kode as kode,i.bank_account_number as bank_account_number
	FROM 0_gl_trans as gl
		LEFT JOIN 0_chart_master as cm ON gl.account = cm.account_code
		LEFT JOIN 0_refs as refs ON (gl.type=refs.type AND gl.type_no=refs.id)
		LEFT JOIN 0_audit_trail as audit ON (gl.type=audit.type AND gl.type_no=audit.trans_no AND NOT ISNULL(gl_seq))
		LEFT JOIN 0_users as user ON (audit.user=user.id)
	# all this below just to retrieve doc_date :>
		LEFT JOIN 0_supp_trans st ON gl.type_no=st.trans_no AND st.type=gl.type AND (gl.type!=".ST_JOURNAL." OR gl.person_id=st.supplier_id)
		LEFT JOIN 0_grn_batch grn ON grn.id=gl.type_no AND gl.type=".ST_SUPPRECEIVE." AND gl.person_id=grn.supplier_id
		LEFT JOIN 0_debtor_trans dt ON gl.type_no=dt.trans_no AND dt.type=gl.type AND (gl.type!=".ST_JOURNAL." OR gl.person_id=dt.debtor_no)
		LEFT JOIN 0_bank_trans bt ON bt.type=gl.type AND bt.trans_no=gl.type_no AND bt.amount <> 0
			 AND bt.person_type_id=gl.person_type_id AND bt.person_id=gl.person_id
		LEFT JOIN 0_journal j ON j.type=gl.type AND j.trans_no=gl.type_no
		LEFT JOIN 0_bank_accounts i ON i.account_code=gl.account and i.account_type!=3"

		." WHERE gl.type= ".db_escape($type) 
		." AND gl.type_no = ".db_escape($trans_id)
		." AND gl.amount < 0"
		." ORDER BY tran_date, counter";
	//return $sql;
	return db_query($sql, "The gl transactions could not be retrieved");
}


function get_gl_trans3($ref)
{
	$sql = "SELECT gl.*, cm.account_name, IFNULL(refs.reference, '') AS reference, user.real_name, 
			COALESCE(st.tran_date, dt.tran_date, bt.trans_date, grn.delivery_date, gl.tran_date) as doc_date,
			IF(ISNULL(st.supp_reference), '', st.supp_reference) AS supp_reference,
			i.bank_name as bank_name,i.kode as kode,i.bank_account_number as bank_account_number
	FROM 0_gl_trans as gl
		LEFT JOIN 0_chart_master as cm ON gl.account = cm.account_code
		LEFT JOIN 0_refs as refs ON (gl.type=refs.type AND gl.type_no=refs.id)
		LEFT JOIN 0_audit_trail as audit ON (gl.type=audit.type AND gl.type_no=audit.trans_no AND NOT ISNULL(gl_seq))
		LEFT JOIN 0_users as user ON (audit.user=user.id)
	# all this below just to retrieve doc_date :>
		LEFT JOIN 0_supp_trans st ON gl.type_no=st.trans_no AND st.type=gl.type AND (gl.type!=".ST_JOURNAL." OR gl.person_id=st.supplier_id)
		LEFT JOIN 0_grn_batch grn ON grn.id=gl.type_no AND gl.type=".ST_SUPPRECEIVE." AND gl.person_id=grn.supplier_id
		LEFT JOIN 0_debtor_trans dt ON gl.type_no=dt.trans_no AND dt.type=gl.type AND (gl.type!=".ST_JOURNAL." OR gl.person_id=dt.debtor_no)
		LEFT JOIN 0_bank_trans bt ON bt.type=gl.type AND bt.trans_no=gl.type_no AND bt.amount <> 0
			 AND bt.person_type_id=gl.person_type_id AND bt.person_id=gl.person_id
		LEFT JOIN 0_journal j ON j.type=gl.type AND j.trans_no=gl.type_no
		LEFT JOIN 0_bank_accounts i ON i.account_code=gl.account"

		." WHERE gl.reference= ".db_escape($ref) 
		." ORDER BY tran_date, counter";
	//return $sql;
	return db_query($sql, "The gl transactions could not be retrieved");
}


function get_gl_bank($ref)
{
	$sql = "SELECT j.*
	FROM ".TB_PREF."bank_trans as i
		LEFT JOIN ".TB_PREF."bank_accounts j ON j.id=i.bank_act"

		." WHERE i.ref= ".db_escape($ref)." " ;

	return db_query($sql, "The gl transactions could not be retrieved");
}

function get_bank($id)
{
	$sql = "SELECT * from ".TB_PREF."bank_accounts "

		." WHERE id= ".db_escape($id)." " ;

	return db_query($sql, "The gl transactions could not be retrieved");
}

//--------------------------------------------------------------------------------

function get_gl_wo_cost_trans($trans_id, $cost_type=-1, $all_gl=false)
{
	$sql = "SELECT costing.*, gl.*, chart.account_name, com.memo_
		FROM "
		.TB_PREF."wo_costing costing, "
		.TB_PREF."gl_trans gl LEFT JOIN ".TB_PREF."comments com ON gl.type=com.type	AND gl.type_no=com.id,"
		.TB_PREF."chart_master chart
		WHERE 
			costing.workorder_id=".db_escape($trans_id)
		."	AND chart.account_code=gl.account
			AND gl.type=costing.trans_type
			AND gl.type_no=costing.trans_no";
	if ($cost_type != -1)
		$sql .= " AND costing.cost_type=".db_escape($cost_type);
	$sql .= $all_gl ? " AND amount != 0" : " AND amount < 0";

	return db_query($sql, "The gl transactions could not be retrieved");
}

function get_gl_wo_issue_trans($trans_id, $person_id=-1, $all_gl=false)
{
	$sql = "SELECT issue.*, gl.*, chart.account_name, com.memo_
		FROM "
			.TB_PREF."wo_issues issue,"
			.TB_PREF."gl_trans gl LEFT JOIN ".TB_PREF."comments com ON gl.type=com.type	AND gl.type_no=com.id,"
			.TB_PREF."chart_master chart
		WHERE issue.workorder_id=".db_escape($trans_id)
		 ." AND chart.account_code=gl.account
			AND gl.type=".ST_MANUISSUE." AND gl.type_no=issue.issue_no";
//			." AND gl.person_type_id=".PT_WORKORDER;
	if ($person_id != -1)
		$sql .= " AND gl.person_id=".db_escape($person_id);
	$sql .= $all_gl ? " AND amount != 0" : " AND amount < 0";
	$sql .= " ORDER BY type, type_no";
	return db_query($sql, "The gl transactions could not be retrieved");
}

function get_gl_wo_productions($trans_id, $all_gl=false)
{
	$sql = "SELECT rcv.*, gl.*, chart.account_name, com.memo_
		FROM "
		.TB_PREF."wo_manufacture rcv, "
		.TB_PREF."gl_trans gl LEFT JOIN ".TB_PREF."comments com ON gl.type=com.type	AND gl.type_no=com.id,"
		.TB_PREF."chart_master chart
		WHERE 
			rcv.workorder_id=".db_escape($trans_id)
		."	AND chart.account_code=gl.account
			AND gl.type=".ST_MANURECEIVE."
			AND gl.type_no=rcv.id
			AND amount != 0 "
		.($all_gl ? " AND amount != 0" : " AND amount < 0")
		." ORDER BY type, type_no";

	return db_query($sql, "The gl transactions could not be retrieved");
}

function get_gl_balance_from_to($from_date, $to_date, $account, $dimension=0, $dimension2=0)
{
	$from = date2sql($from_date);
	$to = date2sql($to_date);

    $sql = "SELECT SUM(amount) 
    FROM ".TB_PREF."gl_trans trans
		LEFT JOIN ".TB_PREF."voided v ON trans.type_no=v.id AND v.type=trans.type
		WHERE account='$account' and v.id is null ";
	if ($from_date != "")
		$sql .= "  AND tran_date > '$from'";
	if ($to_date != "")
		$sql .= "  AND tran_date < '$to'";
	if ($dimension != 0)
  		$sql .= " AND dimension_id = ".($dimension<0 ? 0 : db_escape($dimension));
	if ($dimension2 != 0)
  		$sql .= " AND dimension2_id = ".($dimension2<0 ? 0 : db_escape($dimension2));

	$result = db_query($sql, "The starting balance for account $account could not be calculated");

	$row = db_fetch_row($result);
	return $row[0];
}

//--------------------------------------------------------------------------------

function get_gl_trans_from_to($from_date, $to_date, $account, $dimension=0, $dimension2=0)
{
	$from = date2sql($from_date);
	$to = date2sql($to_date);

    $sql = "SELECT SUM(amount) FROM ".TB_PREF."gl_trans trans
		LEFT JOIN ".TB_PREF."voided v ON trans.type_no=v.id AND v.type=trans.type
		WHERE account='$account' and v.id is null ";
	if ($from_date != "")
		$sql .= " AND tran_date >= '$from'";
	if ($to_date != "")
		$sql .= " AND tran_date <= '$to'";
	if ($dimension != 0)
  		$sql .= " AND dimension_id = ".($dimension<0 ? 0 : db_escape($dimension));
	if ($dimension2 != 0)
  		$sql .= " AND dimension2_id = ".($dimension2<0 ? 0 : db_escape($dimension2));

  		$sql .= "AND posting = 1";

	$result = db_query($sql, "Transactions for account $account could not be calculated");

	$row = db_fetch_row($result);
	return (float)$row[0];
	//return $sql;
}
//--------------------------------------------------------------------------------

function get_gl_posting($from_date, $to_date, $account, $dimension=0, $dimension2=0)
{
	$from = date2sql($from_date);
	$to = date2sql($to_date);

    $sql = "SELECT posting FROM ".TB_PREF."gl_trans trans
		LEFT JOIN ".TB_PREF."voided v ON trans.type_no=v.id AND v.type=trans.type
		WHERE account='$account' and v.id is null ";
	if ($from_date != "")
		$sql .= " AND tran_date >= '$from'";
	if ($to_date != "")
		$sql .= " AND tran_date <= '$to'";
	if ($dimension != 0)
  		$sql .= " AND dimension_id = ".($dimension<0 ? 0 : db_escape($dimension));
	if ($dimension2 != 0)
  		$sql .= " AND dimension2_id = ".($dimension2<0 ? 0 : db_escape($dimension2));

  		$sql .= "AND posting = 1";

	$result = db_query($sql, "Transactions for account $account could not be calculated");

	$row = db_fetch_row($result);
	return $row[0];	
}

//----------------------------------------------------------------------------------------------------
function get_balance($account, $dimension, $dimension2, $from, $to, $from_incl=true, $to_incl=true) 
{
	$from_date = date2sql($from);
	$to_date = date2sql($to);
	/*
	$sql = "SELECT	SUM(IF(amount >= 0, amount, 0)) as debit, 
					SUM(IF(amount < 0, -amount, 0)) as credit,
					SUM(amount) as balance,type,type_no 
		FROM ".TB_PREF."gl_trans trans,"
			.TB_PREF."chart_master coa,"
			.TB_PREF."chart_types act_type, "
			.TB_PREF."chart_class act_class
		WHERE trans.account=coa.account_code
			AND coa.account_type=act_type.id 
		AND act_type.class_id=act_class.cid"
		."  ".($from_incl ? "AND tran_date >= '$from_date'" : "")
		." AND ".($to_incl ? "tran_date <= '$to_date'" : "tran_date < '$to_date'")
		.($account == null ? '' : " AND account=".db_escape($account))
		.($dimension == 0 ? ''  : " AND dimension_id = ".($dimension<0 ? 0 : db_escape($dimension)))
		.($dimension2 == 0 ? '' : " AND dimension2_id = ".($dimension2<0 ? 0 : db_escape($dimension2)));
	*/
	// /LEFT JOIN ".TB_PREF."refs ref ON trans.type_no=ref.id AND ref.type=trans.type
	//and ref.reference not like 'M--%' "
	$sql="SELECT	SUM(IF(amount >= 0, amount, 0)) as debit, 
					SUM(IF(amount < 0, -amount, 0)) as credit,
					SUM(amount) as balance
		FROM ".TB_PREF."gl_trans trans
		inner join ".TB_PREF."chart_master coa on trans.account=coa.account_code
		inner join ".TB_PREF."chart_types act_type on coa.account_type=act_type.id
		inner join ".TB_PREF."chart_class act_class on act_type.class_id=act_class.cid
		LEFT JOIN ".TB_PREF."voided v ON trans.type_no=v.id AND v.type=trans.type
		
		where v.id IS NULL  "
		.($from_incl ? "AND tran_date >= '$from_date'" : "")
		." AND ".($to_incl ? "tran_date <= '$to_date'" : "tran_date < '$to_date'")
		.($account == null ? '' : " AND account=".db_escape($account))
		.($dimension == 0 ? ''  : " AND dimension_id = ".($dimension<0 ? 0 : db_escape($dimension)))
		.($dimension2 == 0 ? '' : " AND dimension2_id = ".($dimension2<0 ? 0 : db_escape($dimension2)));
		;
	//if($account=='62002' and $from_incl==false)
	//if($account=='51004')
	//	echo $sql;
		//LEFT JOIN ".TB_PREF."voided v ON trans.type_no=v.id AND v.type=trans.type
		//." AND v.id is null"
	$result = db_query($sql,"No general ledger accounts were returned");
	//if($account==63003001)
	//	echo $sql;
	return db_fetch($result);
}

function get_balance_like($account, $dimension, $dimension2, $from, $to, $from_incl=true, $to_incl=true) 
{
	$from_date = date2sql($from);
	$to_date = date2sql($to);
	/*$sql = "SELECT	SUM(IF(amount >= 0, amount, 0)) as debit, 
					SUM(IF(amount < 0, -amount, 0)) as credit,
					SUM(amount) as balance 
		FROM ".TB_PREF."gl_trans trans,"
			.TB_PREF."chart_master coa,"
			.TB_PREF."chart_types act_type, "
			.TB_PREF."chart_class act_class
		WHERE trans.account=coa.account_code
			AND coa.account_type=act_type.id 
		AND act_type.class_id=act_class.cid"
		."  ".($from_incl ? "AND tran_date >= '$from_date'" : "")
		." AND ".($to_incl ? "tran_date <= '$to_date'" : "tran_date < '$to_date'")
		.($account == null ? '' : " AND account like '".$account."%'")
		.($dimension == 0 ? ''  : " AND dimension_id = ".($dimension<0 ? 0 : db_escape($dimension)))
		.($dimension2 == 0 ? '' : " AND dimension2_id = ".($dimension2<0 ? 0 : db_escape($dimension2)));
		*/
		$sql="SELECT	SUM(IF(amount >= 0, amount, 0)) as debit, 
					SUM(IF(amount < 0, -amount, 0)) as credit,
					SUM(amount) as balance
		FROM ".TB_PREF."gl_trans trans
		inner join ".TB_PREF."chart_master coa on trans.account=coa.account_code
		inner join ".TB_PREF."chart_types act_type on coa.account_type=act_type.id
		inner join ".TB_PREF."chart_class act_class on act_type.class_id=act_class.cid
		LEFT JOIN ".TB_PREF."voided v ON trans.type_no=v.id AND v.type=trans.type
		where v.id is null "
		.($from_incl ? "AND tran_date >= '$from_date'" : "")
		." AND ".($to_incl ? "tran_date <= '$to_date'" : "tran_date < '$to_date'")
		.($account == null ? '' : " AND account like '".$account."%'")
		.($dimension == 0 ? ''  : " AND dimension_id = ".($dimension<0 ? 0 : db_escape($dimension)))
		.($dimension2 == 0 ? '' : " AND dimension2_id = ".($dimension2<0 ? 0 : db_escape($dimension2)));
		;
	//if($account=='62002' and $from_incl==false)
	//if($account=='51004')
	//	echo $sql;
	$result = db_query($sql,"No general ledger accounts were returned");
	//if($account==63003001)
	//	echo $sql;
	return db_fetch($result);
}

//--------------------------------------------------------------------------------

function get_budget_trans_from_to($from_date, $to_date, $account, $dimension=0, $dimension2=0)
{

	$from = date2sql($from_date);
	$to = date2sql($to_date);

	$sql = "SELECT SUM(amount)
		FROM ".TB_PREF."budget_trans
		WHERE account=".db_escape($account);
	if ($from_date != "")
		$sql .= " AND tran_date >= '$from' ";
	if ($to_date != "")
		$sql .= " AND tran_date <= '$to' ";
	if ($dimension != 0)
  		$sql .= " AND dimension_id = ".($dimension<0?0:db_escape($dimension));
	if ($dimension2 != 0)
  		$sql .= " AND dimension2_id = ".($dimension2<0?0:db_escape($dimension2));
	$result = db_query($sql,"No budget accounts were returned");

	$row = db_fetch_row($result);
	return $row[0];
}
//-------------------------------------------------------------------------------------

function exists_gl_budget($date_, $account, $dimension, $dimension2)
{
	$sql = "SELECT account FROM ".TB_PREF."budget_trans WHERE account=".db_escape($account)
	." AND tran_date='$date_' AND
		dimension_id=".db_escape($dimension)." AND dimension2_id=".db_escape($dimension2);
	$result = db_query($sql, "Cannot retreive a gl transaction");

    return (db_num_rows($result) > 0);
}

function add_update_gl_budget_trans($date_, $account, $dimension, $dimension2, $amount)
{
	$date = date2sql($date_);

	if (exists_gl_budget($date, $account, $dimension, $dimension2))
		$sql = "UPDATE ".TB_PREF."budget_trans SET amount=".db_escape($amount)
		." WHERE account=".db_escape($account)
		." AND dimension_id=".db_escape($dimension)
		." AND dimension2_id=".db_escape($dimension2)
		." AND tran_date='$date'";
	else
		$sql = "INSERT INTO ".TB_PREF."budget_trans (tran_date,
			account, dimension_id, dimension2_id, amount, memo_) VALUES ('$date',
			".db_escape($account).", ".db_escape($dimension).", "
			.db_escape($dimension2).", ".db_escape($amount).", '')";

	db_query($sql, "The GL budget transaction could not be saved");
}

function delete_gl_budget_trans($date_, $account, $dimension, $dimension2)
{
	$date = date2sql($date_);

	$sql = "DELETE FROM ".TB_PREF."budget_trans WHERE account=".db_escape($account)
	." AND dimension_id=".db_escape($dimension)
	." AND dimension2_id=".db_escape($dimension2)
	." AND tran_date='$date'";
	db_query($sql, "The GL budget transaction could not be deleted");
}

function get_only_budget_trans_from_to($from_date, $to_date, $account, $dimension=0, $dimension2=0)
{

	$from = date2sql($from_date);
	$to = date2sql($to_date);

	$sql = "SELECT SUM(amount) FROM ".TB_PREF."budget_trans
		WHERE account=".db_escape($account)
		." AND tran_date >= '$from' AND tran_date <= '$to'
		 AND dimension_id = ".db_escape($dimension)
		 ." AND dimension2_id = ".db_escape($dimension2);
	$result = db_query($sql,"No budget accounts were returned");

	$row = db_fetch_row($result);
	return $row[0];
}

//--------------------------------------------------------------------------------
//	Stores journal/bank transaction tax details if applicable
//
function add_gl_tax_details($gl_code, $trans_type, $trans_no, $amount, $ex_rate, $date, $memo, $included=0, $net_amount = null, $jasa = null)
{
	$tax_type = is_tax_account($gl_code);
	if(!$tax_type) return;	// $gl_code is not tax account
	
	$tax = get_tax_type($tax_type);
	if ($trans_type == ST_SALESINVOICE || $trans_type == ST_CUSTDELIVERY || $trans_type == ST_CUSTCREDIT)
		$amount = -$amount;
	// we have to restore net amount as we cannot know the base amount
	if ($net_amount===null) {
		if ($tax['rate'] == 0) {
			$net_amount = 0;
		} else { 
			// calculate net amount
			$net_amount = $amount/$tax['rate']*100; 
		}
	}
	add_trans_tax_details($trans_type, $trans_no, $tax['id'], $tax['rate'], $included, 
		$amount, $net_amount, $ex_rate, $date, $memo, null,$jasa);

}

//--------------------------------------------------------------------------------
//
//	Store transaction tax details for fiscal purposes with 'freezed' 
//	actual tax type rate.
//
function add_trans_tax_details($trans_type, $trans_no, $tax_id, $rate, $included,
	$amount, $net_amount, $ex_rate, $tran_date, $memo, $reg_type=null,$jasa=null)
{
	// guess tax register if not set
	if (!isset($reg_type))
		$reg_type = in_array($trans_type, array(ST_SUPPINVOICE, ST_SUPPCREDIT)) ? TR_OUTPUT
				: in_array($trans_type, array(ST_SALESINVOICE, ST_CUSTCREDIT)) ? TR_INPUT : null;

	echo $sql = "INSERT INTO ".TB_PREF."trans_tax_details 
		(trans_type, trans_no, tran_date, tax_type_id, rate, ex_rate,
			included_in_price, net_amount, amount, memo, reg_type,jasa)
		VALUES (".db_escape($trans_type)."," . db_escape($trans_no).",'"
				.date2sql($tran_date)."',".db_escape($tax_id).","
				.db_escape($rate).",".db_escape($ex_rate).",".($included ? 1:0).","
				.db_escape($net_amount).","
				.db_escape($amount).",".db_escape($memo).",".db_escape($reg_type, true).",".db_escape($jasa, true).")";

	db_query($sql, "Cannot save trans tax details");

}
//----------------------------------------------------------------------------------------

function get_trans_tax_details($trans_type, $trans_no)
{
	$sql = "SELECT tax_details.*,
				tax_type.name AS tax_type_name,
				tax_details.rate AS effective_rate,
				tax_type.rate AS rate
		FROM ".TB_PREF."trans_tax_details tax_details,
			".TB_PREF."tax_types tax_type
		WHERE 
			trans_type = ".db_escape($trans_type)."
		AND trans_no = ".db_escape($trans_no)."
		AND (net_amount != 0 OR amount != 0)
		AND tax_type.id = tax_details.tax_type_id";

	return db_query($sql, "The transaction tax details could not be retrieved");
}

//----------------------------------------------------------------------------------------

function posting_journal($type, $type_no, $stat)
{
	if($stat == 0){
		$sql = "UPDATE ".TB_PREF."journal SET posting=1
			WHERE trans_no=".db_escape($type_no)
			." AND type=".db_escape($type);

		db_query($sql, "Update Posting Journal Failed");

	}else{
		$sql = "UPDATE ".TB_PREF."gl_trans SET posting=0
			WHERE type_no=".db_escape($type_no)
			." AND type=".db_escape($type);

		db_query($sql, "Update Posting Journal Failed");
	}


	/*$sql = "UPDATE ".TB_PREF."gl_trans SET tran_date='".date('Y-m-d')."'
		WHERE type_no=".db_escape($type_no)
		." AND type=".db_escape($type);

	db_query($sql, "Update Posting Journal Failed");*/
}
//----------------------------------------------------------------------------------------

function void_trans_tax_details($type, $type_no)
{
	$sql = "UPDATE ".TB_PREF."trans_tax_details SET amount=0, net_amount=0
		WHERE trans_no=".db_escape($type_no)
		." AND trans_type=".db_escape($type);

	db_query($sql, "The transaction tax details could not be voided");
}

//----------------------------------------------------------------------------------------

function clear_trans_tax_details($type, $type_no)
{
	$sql = "DELETE FROM ".TB_PREF."trans_tax_details 
		WHERE trans_no=".db_escape($type_no)
		." AND trans_type=".db_escape($type);

	db_query($sql, "The transaction tax details could not be cleared");
}

function get_taxes($from, $to, $also_zero_purchases=true)
{
	$fromdate = date2sql($from);
	$todate = date2sql($to);

	$sql = "SELECT 
				SUM(IF(trans_type=".ST_SUPPCREDIT.",-1,1)*
				IF((reg_type=".TR_OUTPUT.")"
					." || ((trans_type IN(".ST_SUPPINVOICE.",".ST_SUPPCREDIT.") OR (trans_type=".ST_JOURNAL." AND reg_type=".TR_INPUT."))
					), net_amount*ex_rate,0)
				) net_output,

				SUM(IF(trans_type=".ST_SUPPCREDIT.",-1,1)*
				IF((reg_type=".TR_OUTPUT.")"
					." || ((trans_type IN(".ST_SUPPINVOICE.",".ST_SUPPCREDIT.") OR (trans_type=".ST_JOURNAL." AND reg_type=".TR_INPUT."))
					), amount*ex_rate,0)) payable,

				SUM(IF(trans_type IN(".ST_SUPPCREDIT."),-1,1)*
				IF(reg_type=".TR_INPUT
					. ($also_zero_purchases ? '': " AND tax_type_id AND taxrec.rate")
					.", net_amount*ex_rate, 0)) net_input,

				SUM(IF(trans_type IN(".ST_SUPPCREDIT."),-1,1)*
				IF(reg_type=".TR_INPUT
					. ($also_zero_purchases ? '': " AND tax_type_id AND taxrec.rate ") 
					.", amount*ex_rate, 0)) collectible,
				taxrec.rate,
				ttype.id,
				ttype.name
		FROM ".TB_PREF."trans_tax_details taxrec LEFT JOIN ".TB_PREF."tax_types ttype ON taxrec.tax_type_id=ttype.id
		WHERE taxrec.trans_type IN (".implode(',',
			array(ST_SALESINVOICE, ST_CUSTCREDIT, ST_SUPPINVOICE, ST_SUPPCREDIT, ST_JOURNAL)).")
			AND taxrec.tran_date >= '$fromdate'
			AND taxrec.tran_date <= '$todate'
		GROUP BY ttype.id";

		// display_error($sql);
    return db_query($sql,"Cannot retrieve tax summary");
}

function get_tax_summary($from, $to, $also_zero_purchases=true)
{
	$fromdate = date2sql($from);
	$todate = date2sql($to);

	$sql = "SELECT 
				SUM(IF(trans_type=".ST_SUPPCREDIT.",-1,1)*
				IF((reg_type=".TR_OUTPUT.")"
					." || ((trans_type IN(".ST_SUPPINVOICE.",".ST_SUPPCREDIT.") OR (trans_type=".ST_JOURNAL." AND reg_type=".TR_INPUT."))
					), net_amount*ex_rate,0)
				) net_output,

				SUM(IF(trans_type=".ST_SUPPCREDIT.",-1,1)*
				IF((reg_type=".TR_OUTPUT.")"
					." || ((trans_type IN(".ST_SUPPINVOICE.",".ST_SUPPCREDIT.") OR (trans_type=".ST_JOURNAL." AND reg_type=".TR_INPUT."))
					), amount*ex_rate,0)) payable,

				SUM(IF(trans_type IN(".ST_SUPPCREDIT."),-1,1)*
				IF(reg_type=".TR_INPUT
					. ($also_zero_purchases ? '': " AND tax_type_id AND taxrec.rate")
					.", net_amount*ex_rate, 0)) net_input,

				SUM(IF(trans_type IN(".ST_SUPPCREDIT."),-1,1)*
				IF(reg_type=".TR_INPUT
					. ($also_zero_purchases ? '': " AND tax_type_id AND taxrec.rate ") 
					.", amount*ex_rate, 0)) collectible,
				taxrec.rate,taxrec.tran_date,taxrec.tax_type_id,
				ttype.id,
				ttype.name,
				ttype.wth
		FROM ".TB_PREF."trans_tax_details taxrec LEFT JOIN ".TB_PREF."tax_types ttype ON taxrec.tax_type_id=ttype.id
		WHERE taxrec.trans_type IN (".implode(',',
			array(ST_SALESINVOICE, ST_CUSTCREDIT, ST_SUPPINVOICE, ST_SUPPCREDIT, ST_JOURNAL)).")
			AND taxrec.tran_date >= '$fromdate'
			AND taxrec.tran_date <= '$todate'
		GROUP BY ttype.id";
		//,ST_BANKPAYMENT,ST_BANKDEPOSIT
		// display_error($sql);
    //return $sql;
    return db_query($sql,"Cannot retrieve tax summary");
}

function get_tax_detail($from, $to, $tipe,$tpe,$wth=0)
{
	$fromdate = date2sql($from);
	$todate = date2sql($to);
	$tp=13;
	if($tpe=='k')
	$tp=10;
	if($tpe=='m')
	$tp=20;
	$sql = "SELECT 
				taxrec.*,
				ttype.id,
				ttype.name,c.reference
		FROM ".TB_PREF."trans_tax_details taxrec 
		LEFT JOIN ".TB_PREF."tax_types ttype ON taxrec.tax_type_id=ttype.id
		inner JOIN ".TB_PREF."fp_trans c ON c.type=taxrec.trans_type and c.id=taxrec.trans_no
		WHERE taxrec.tax_type_id = $tipe
			AND memo != 'auto'
			AND taxrec.tran_date >= '$fromdate'
			AND taxrec.tran_date <= '$todate' ";
		if($wth==0)
		$sql .= "AND taxrec.amount > 0";
		$sql .= " group by tran_date,tax_type_id";

		// display_error($sql);
	//return $sql;
    return db_query($sql,"Cannot retrieve tax summary");
}


function npwp_supp($tran_no)
{
	$fromdate = date2sql($from);
	$todate = date2sql($to);

	$sql = "SELECT 
				a.trans_no,a.supplier_id,
				b.*
		FROM ".TB_PREF."supp_trans a 
		LEFT JOIN ".TB_PREF."suppliers b ON a.supplier_id=b.supplier_id
		WHERE a.trans_no like '".$tran_no."'";

		// display_error($sql);
    return db_query($sql,"Cannot retrieve tax summary");
}

function npwp_cust($tran_no)
{
	$fromdate = date2sql($from);
	$todate = date2sql($to);

	$sql = "SELECT 
				a.trans_no,a.debtor_no,
				b.*
		FROM ".TB_PREF."debtor_trans a 
		LEFT JOIN ".TB_PREF."debtors_master b ON a.debtor_no=b.debtor_no
		WHERE a.trans_no like '".$tran_no."'";

		// display_error($sql);
    return db_query($sql,"Cannot retrieve tax summary");
}

//--------------------------------------------------------------------------------------------------

function exists_gl_trans($type, $trans_id)
{
	$sql = "SELECT type_no FROM ".TB_PREF."gl_trans WHERE type=".db_escape($type)
		." AND type_no=".db_escape($trans_id);
	$result = db_query($sql, "Cannot retreive a gl transaction");

    return (db_num_rows($result) > 0);
}

//--------------------------------------------------------------------------------------------------

function void_gl_trans($type, $trans_id, $nested=false)
{
	if (!$nested)
		begin_transaction();

	$sql = "UPDATE ".TB_PREF."gl_trans SET amount=0 WHERE type=".db_escape($type)
	." AND type_no=".db_escape($trans_id);

	db_query($sql, "could not void gl transactions for type=$type and trans_no=$trans_id");

	if (!$nested)
		commit_transaction();
}

//----------------------------------------------------------------------------------------

function clear_gl_trans($type, $trans_id, $nested=false)
{
	if (!$nested)
		begin_transaction();

	$sql = "DELETE FROM ".TB_PREF."gl_trans WHERE type=".db_escape($type)
	." AND type_no=".db_escape($trans_id);

	db_query($sql, "could not clear gl transactions for type=$type and trans_no=$trans_id");

	if (!$nested)
		commit_transaction();
}

function get_sql_for_journal_inquiry($filter, $from, $to, $ref='', $memo='', $alsoclosed=false,
		 $user_id=null, $contractor_id=null, $dimension=null)
{

	//".($dimension ? " -SUM(IF(dim.dimension in(gl.dimension_id,gl.dimension2_id), gl.amount, 0)) as amount,":" SUM(IF(gl.amount>0, gl.amount,0)) as amount,")."
		
	$sql = "SELECT	IFNULL(a.gl_seq,0) as gl_seq,
		gl.tran_date,
		gl.type as trans_type,
		IFNULL(MAX(supp.supp_name), MAX(cust.name)) as name,
		/*IF(ISNULL(st.supp_reference), '', st.supp_reference) AS supp_reference,*/
		refs.reference,
		IFNULL((dt.ov_amount+dt.ov_gst),ABS(bt.amount)) as amount,
		gl.memo_,
		IF(ISNULL(u.user_id),'',u.user_id) as user_id,
		j.type as jtype,
		j.trans_no as jtrans,
		gl.posting as postinggl,
		j.posting,
		j.amount as amount2,
		gl.type_no as trans_no";

	if ($contractor_id > 0) {
		$sql.= ", st.supplier_id, dt.debtor_no ";
	}

	$sql.= " FROM ".TB_PREF."gl_trans as gl
		 LEFT JOIN ".TB_PREF."audit_trail as a ON
			(gl.type=a.type AND gl.type_no=a.trans_no)
		 LEFT JOIN ".TB_PREF."comments as com ON
			(gl.type=com.type AND gl.type_no=com.id)
		 LEFT JOIN ".TB_PREF."refs as refs ON
			(gl.type=refs.type AND gl.type_no=refs.id)
		 LEFT JOIN ".TB_PREF."users as u ON
			a.user=u.id
			
		left JOIN ".TB_PREF."voided v ON v.type=gl.type AND v.id=gl.type_no
		left JOIN ".TB_PREF."journal j ON j.type=gl.type AND j.trans_no=gl.type_no
		left JOIN ".TB_PREF."bank_trans bt ON bt.type=gl.type AND bt.trans_no=gl.type_no
	 	 LEFT JOIN ".TB_PREF."debtor_trans dt ON dt.type=gl.type AND gl.type_no=dt.trans_no
	 	 LEFT JOIN ".TB_PREF."debtors_master cust ON gl.person_type_id=2 AND gl.person_id=cust.debtor_no
	 	 LEFT JOIN ".TB_PREF."supp_trans st ON st.type=gl.type AND gl.type_no=st.trans_no
	 	 LEFT JOIN ".TB_PREF."suppliers supp ON gl.person_type_id=3 AND gl.person_id=supp.supplier_id"
	 	 .($dimension ? 
		 " LEFT JOIN (SELECT type, type_no, MAX(IFNULL(dimension_id, dimension2_id)) dimension FROM ".TB_PREF."gl_trans GROUP BY type, type_no) dim 
		 		ON gl.type=dim.type AND gl.type_no=dim.type_no" : '')
		." WHERE gl.tran_date >= '" . date2sql($from) . "'
		AND gl.tran_date <= '" . date2sql($to) . "'
		AND gl.amount!=0 and v.id is null";
	if ($ref) {
		$sql .= " AND refs.reference LIKE ". db_escape("%$ref%");
	}
	if ($memo) {
		$sql .= " AND com.memo_ LIKE ". db_escape("%$memo%");
	}
	if ($filter != -1) {
		$sql .= " AND gl.type=".db_escape($filter);
	}
	
	if (!$alsoclosed) {
		$sql .= " AND gl_seq=0";
	}
 	else
 		$sql .= " AND NOT ISNULL(a.gl_seq)";
	
	if ($user_id != null)
		$sql .= " AND user_id = ".db_escape($user_id);

	if ($contractor_id > 0) {
		$sql.= " AND (dt.debtor_no =".$contractor_id;
		$sql.= " OR st.supplier_id =".$contractor_id.") ";
	}	

	if ($dimension != null)
		$sql .= " AND dim.dimension = ".db_escape($dimension);

	$sql .= " GROUP BY gl.tran_date, a.gl_seq, gl.type, gl.type_no,refs.reference";

	return $sql;
}


function get_sql_for_armfee_inquiry($filter, $from, $to)
{

	//".($dimension ? " -SUM(IF(dim.dimension in(gl.dimension_id,gl.dimension2_id), gl.amount, 0)) as amount,":" SUM(IF(gl.amount>0, gl.amount,0)) as amount,")."
		
	$sql = "SELECT	IFNULL(a.gl_seq,0) as gl_seq,
		gl.tran_date,
		gl.type as trans_type,
		gl.type_no as trans_no,
		cust.*,
		IF(ISNULL(st.supp_reference), '', st.supp_reference) AS supp_reference,
		refs.reference,
		(dt.ov_amount+dt.ov_gst) as amount,
		(dt.ov_amount) as amount2,
		dt.trans_no,
		com.memo_,
		IF(ISNULL(u.user_id),'',u.user_id) as user_id,
		j.type as jtype,
		j.trans_no as jtrans,
		j.posting";

	if (@$contractor_id > 0) {
		$sql.= ", st.supplier_id, dt.debtor_no ";
	}

	$sql.= " FROM ".TB_PREF."gl_trans as gl
		 LEFT JOIN ".TB_PREF."audit_trail as a ON
			(gl.type=a.type AND gl.type_no=a.trans_no)
		 LEFT JOIN ".TB_PREF."comments as com ON
			(gl.type=com.type AND gl.type_no=com.id)
		 LEFT JOIN ".TB_PREF."refs as refs ON
			(gl.type=refs.type AND gl.type_no=refs.id)
		 LEFT JOIN ".TB_PREF."users as u ON
			a.user=u.id
			
		left JOIN ".TB_PREF."journal j ON j.type=gl.type AND j.trans_no=gl.type_no
	 	 LEFT JOIN ".TB_PREF."debtor_trans dt ON dt.type=gl.type AND gl.type_no=dt.trans_no
	 	 LEFT JOIN ".TB_PREF."debtors_master cust ON dt.debtor_no=cust.debtor_no
	 	 LEFT JOIN ".TB_PREF."supp_trans st ON st.type=gl.type AND gl.type_no=st.trans_no
	 	 LEFT JOIN ".TB_PREF."suppliers supp ON gl.person_type_id=3 AND gl.person_id=supp.supplier_id"
	 	 .(@$dimension ? 
		 " LEFT JOIN (SELECT type, type_no, MAX(IFNULL(dimension_id, dimension2_id)) dimension FROM ".TB_PREF."gl_trans GROUP BY type, type_no) dim 
		 		ON gl.type=dim.type AND gl.type_no=dim.type_no" : '')
		." WHERE gl.tran_date >= '" . date2sql($from) . "'
		AND gl.tran_date <= '" . date2sql($to) . "'
		AND gl.amount!=0";
	if (@$ref) {
		$sql .= " AND refs.reference LIKE ". db_escape("%$ref%");
	}
	if (@$memo) {
		$sql .= " AND com.memo_ LIKE ". db_escape("%$memo%");
	}
	if (@$filter != -1) {
		$sql .= " AND gl.type=".db_escape($filter);
	}
	if (!@$alsoclosed) {
		$sql .= " AND gl_seq=0";
	}
 	else
 		$sql .= " AND NOT ISNULL(a.gl_seq)";

	if (@$user_id != null)
		$sql .= " AND user_id = ".db_escape($user_id);

	if (@$contractor_id > 0) {
		$sql.= " AND (dt.debtor_no =".$contractor_id;
		$sql.= " OR st.supplier_id =".$contractor_id.") ";
	}	

	if (@$dimension != null)
		$sql .= " AND dim.dimension = ".db_escape($dimension);

	$sql .= " GROUP BY gl.tran_date, a.gl_seq, gl.type, gl.type_no,refs.reference";

	return $sql;
}

function get_pajak_masukan($filter, $from, $to)
{

	//".($dimension ? " -SUM(IF(dim.dimension in(gl.dimension_id,gl.dimension2_id), gl.amount, 0)) as amount,":" SUM(IF(gl.amount>0, gl.amount,0)) as amount,")."
		
	$sql = "SELECT	IFNULL(a.gl_seq,0) as gl_seq,
		gl.tran_date,
		gl.type as trans_type,
		gl.type_no as trans_no,
		supp.*,
		IF(ISNULL(st.supp_reference), '', st.supp_reference) AS supp_reference,
		refs.reference,
		gl.amount as amount,
		(dt.ov_amount) as amount2,
		com.memo_,
		IF(ISNULL(u.user_id),'',u.user_id) as user_id,
		j.type as jtype,
		j.trans_no as jtrans,
		j.posting,
		ttax.id as idtax,ttax.net_amount,ttax.fp";

	if (@$contractor_id > 0) {
		$sql.= ", st.supplier_id, dt.debtor_no ";
	}

	$sql.= " FROM ".TB_PREF."gl_trans as gl
		 LEFT JOIN ".TB_PREF."audit_trail as a ON
			(gl.type=a.type AND gl.type_no=a.trans_no)
		 LEFT JOIN ".TB_PREF."comments as com ON
			(gl.type=com.type AND gl.type_no=com.id)
		 LEFT JOIN ".TB_PREF."refs as refs ON
			(gl.type=refs.type AND gl.type_no=refs.id)
		 LEFT JOIN ".TB_PREF."users as u ON
			a.user=u.id
			
		left JOIN ".TB_PREF."trans_tax_details ttax ON ttax.trans_type=gl.type AND ttax.trans_no=gl.type_no
		left JOIN ".TB_PREF."journal j ON j.type=gl.type AND j.trans_no=gl.type_no
	 	 LEFT JOIN ".TB_PREF."debtor_trans dt ON dt.type=gl.type AND gl.type_no=dt.trans_no
	 	 LEFT JOIN ".TB_PREF."debtors_master cust ON dt.debtor_no=cust.debtor_no
	 	 LEFT JOIN ".TB_PREF."supp_trans st ON st.type=gl.type AND gl.type_no=st.trans_no
	 	 LEFT JOIN ".TB_PREF."suppliers supp ON supp.supplier_id=st.supplier_id"
	 	 .(@$dimension ? 
		 " LEFT JOIN (SELECT type, type_no, MAX(IFNULL(dimension_id, dimension2_id)) dimension FROM ".TB_PREF."gl_trans GROUP BY type, type_no) dim 
		 		ON gl.type=dim.type AND gl.type_no=dim.type_no" : '')
		." WHERE gl.tran_date >= '" . date2sql($from) . "'
		AND gl.tran_date <= '" . date2sql($to) . "'
		AND gl.amount!=0
		and gl.account=11703";
	if (@$ref) {
		$sql .= " AND refs.reference LIKE ". db_escape("%$ref%");
	}
	if (@$memo) {
		$sql .= " AND com.memo_ LIKE ". db_escape("%$memo%");
	}
	if (@$filter != -1) {
		$sql .= " AND gl.type=".db_escape($filter);
	}
	if (!@$alsoclosed) {
		$sql .= " AND gl_seq=0";
	}
 	else
 		$sql .= " AND NOT ISNULL(a.gl_seq)";

	if (@$user_id != null)
		$sql .= " AND user_id = ".db_escape($user_id);

	if (@$contractor_id > 0) {
		$sql.= " AND (dt.debtor_no =".$contractor_id;
		$sql.= " OR st.supplier_id =".$contractor_id.") ";
	}	

	if (@$dimension != null)
		$sql .= " AND dim.dimension = ".db_escape($dimension);

	$sql .= " GROUP BY gl.tran_date, a.gl_seq, gl.type, gl.type_no,refs.reference";

	return $sql;
}

function get_pajak_pph4($filter, $from, $to)
{

	//".($dimension ? " -SUM(IF(dim.dimension in(gl.dimension_id,gl.dimension2_id), gl.amount, 0)) as amount,":" SUM(IF(gl.amount>0, gl.amount,0)) as amount,")."
		
	$sql = "SELECT	IFNULL(a.gl_seq,0) as gl_seq,
		gl.tran_date,
		gl.type as trans_type,
		gl.type_no as trans_no,
		supp.*,
		IF(ISNULL(st.supp_reference), '', st.supp_reference) AS supp_reference,
		refs.reference,
		gl.amount as amount,
		(dt.ov_amount) as amount2,
		com.memo_,
		IF(ISNULL(u.user_id),'',u.user_id) as user_id,
		j.type as jtype,
		j.trans_no as jtrans,
		j.posting,
		ttax.id as idtax,ttax.net_amount,ttax.fp";

	if (@$contractor_id > 0) {
		$sql.= ", st.supplier_id, dt.debtor_no ";
	}

	$sql.= " FROM ".TB_PREF."gl_trans as gl
		 LEFT JOIN ".TB_PREF."audit_trail as a ON
			(gl.type=a.type AND gl.type_no=a.trans_no)
		 LEFT JOIN ".TB_PREF."comments as com ON
			(gl.type=com.type AND gl.type_no=com.id)
		 LEFT JOIN ".TB_PREF."refs as refs ON
			(gl.type=refs.type AND gl.type_no=refs.id)
		 LEFT JOIN ".TB_PREF."users as u ON
			a.user=u.id
			
		left JOIN ".TB_PREF."trans_tax_details ttax ON ttax.trans_type=gl.type AND ttax.trans_no=gl.type_no
		left JOIN ".TB_PREF."journal j ON j.type=gl.type AND j.trans_no=gl.type_no
	 	 LEFT JOIN ".TB_PREF."debtor_trans dt ON dt.type=gl.type AND gl.type_no=dt.trans_no
	 	 LEFT JOIN ".TB_PREF."debtors_master cust ON dt.debtor_no=cust.debtor_no
	 	 LEFT JOIN ".TB_PREF."supp_trans st ON st.type=gl.type AND gl.type_no=st.trans_no
	 	 LEFT JOIN ".TB_PREF."suppliers supp ON supp.supplier_id=st.supplier_id"
	 	 .(@$dimension ? 
		 " LEFT JOIN (SELECT type, type_no, MAX(IFNULL(dimension_id, dimension2_id)) dimension FROM ".TB_PREF."gl_trans GROUP BY type, type_no) dim 
		 		ON gl.type=dim.type AND gl.type_no=dim.type_no" : '')
		." WHERE gl.tran_date >= '" . date2sql($from) . "'
		AND gl.tran_date <= '" . date2sql($to) . "'
		AND gl.amount!=0
		and gl.account=21230";
	if (@$ref) {
		$sql .= " AND refs.reference LIKE ". db_escape("%$ref%");
	}
	if (@$memo) {
		$sql .= " AND com.memo_ LIKE ". db_escape("%$memo%");
	}
	if (@$filter != -1) {
		$sql .= " AND gl.type=".db_escape($filter);
	}
	if (!@$alsoclosed) {
		$sql .= " AND gl_seq=0";
	}
 	else
 		$sql .= " AND NOT ISNULL(a.gl_seq)";

	if (@$user_id != null)
		$sql .= " AND user_id = ".db_escape($user_id);

	if (@$contractor_id > 0) {
		$sql.= " AND (dt.debtor_no =".$contractor_id;
		$sql.= " OR st.supplier_id =".$contractor_id.") ";
	}	

	if (@$dimension != null)
		$sql .= " AND dim.dimension = ".db_escape($dimension);

	$sql .= " GROUP BY gl.tran_date, a.gl_seq, gl.type, gl.type_no,refs.reference";

	return $sql;
}

function get_supp_bytrans($type,$trans_no)
{
	$sql = "SELECT * from ".TB_PREF."debtor_trans a
		 	left join ".TB_PREF."debtors_master b on b.debtor_no=a.debtor_no 
		 	WHERE a.type=".db_escape($type)." and a.trans_no=".db_escape($trans_no)." " ;

	$result=db_query($sql, "The gl transactions could not be retrieved");

	$row = db_fetch($result);
	return $row;
}

function add_fixed_asset($item, $tgl, $amount, $ref)
{

	global $SysPrefs;
	$sql2="INSERT INTO `".TB_PREF."_stock_moves` (`trans_id`, `trans_no`, `stock_id`, `type`, `loc_code`, `tran_date`, `price`, `reference`, `qty`, `standard_cost`) VALUES (NULL, '0', ".db_escape($item).", '25', 'DEF', '".db_escape($tgl)."', '". 
		db_escape($amount)."', '".db_escape($ref)."', '1', '0');";
	$result=db_query($sql2, '');
	return true;
	//$row = db_fetch_row($result);
	//return $row[0];
}

function get_budgets($tgl, $tgl2, $period)
{

	global $SysPrefs;
	$sql2="SELECT a.*,b.account_name 
	FROM `".TB_PREF."budget_trans` a 
	left join `0_chart_master` b on a.account=b.account_code
	WHERE a.tran_date >=".db_escape($tgl)." and a.tran_date <=".db_escape($tgl2)." " ;
	$result=db_query($sql2, '');
	//return true;
	
	return $result;
}

function get_dimension_list()
{
	$sql = "SELECT id, name FROM ".TB_PREF."dimensions";
	$result=db_query($sql, '');
	//return true;
	
	return $result;
 
	
}
function get_parent_subaccount($acount_code)
{
	$sql = "SELECT b.account_code2, b.account_name 
		FROM ".TB_PREF."chart_master a
		inner join ".TB_PREF."chart_master b on a.account_type=b.account_code2
		where a.account_code=".db_escape($acount_code)." ";
	$result=db_query($sql, '');
	//return true;
	$row = db_fetch_row($result);
	return array($row[0],$row[1]);
	//return $sql;
}


function get_subaccount($acount_code)
{
	$sql = "SELECT b.account_code, b.account_name 
		FROM ".TB_PREF."chart_master a
		inner join ".TB_PREF."chart_master b on b.account_type=a.account_code2
		where a.account_code=".db_escape($acount_code)." ";
	$result=db_query($sql, '');
	//if($acount_code==63003)
	//	echo $sql;
	//return true;
	//$row = db_fetch_row($result);
	//return array($row[0],$row[1]);
	return $result;
}


function get_subaccount_angka($acount_code)
{
	$sql = "SELECT a.account_code, a.account_name 
		FROM ".TB_PREF."chart_master a
		where a.account_code like '".($acount_code)."%' ";
	$result=db_query($sql, '');
	//if($acount_code==63003)
	//	echo $sql;
	//return true;
	//$row = db_fetch_row($result);
	//return array($row[0],$row[1]);
	return $result;
}

function cek_type_account($name)
{
	$sql="SELECT a.id as acc1,a.name as lvl1,b.id as acc2,
	b.name as lvl2,
	c.id as acc3,c.name as lvl3,
	d.id as acc4,d.name as lvl4
		from ".TB_PREF."chart_types a
		inner join ".TB_PREF."chart_types b on a.parent=b.id
        left join ".TB_PREF."chart_types c on b.parent=c.id
        left join 0_chart_types d on c.parent=d.id
		where a.name like ".db_escape($name)." ";

	$result=db_query($sql, '');
	//return true;
	$row = db_fetch_row($result);
	return $row;
	//return $sql;
}
function cek_class_account($acount_code)
{
	$sql = "SELECT a.account_code2, a.account_name 
		FROM ".TB_PREF."chart_master a
		inner join ".TB_PREF."chart_types b on a.account_code2=b.id
		where a.account_code2=".db_escape($acount_code)." ";
	$result=db_query($sql, '');
	//return true;
	$row = db_fetch_row($result);
	return $row;
	//return $sql;
}


function get_account_from_to($acount_code,$acount_code2)
{
	$sql = "SELECT  a.*,b.name as head,c.id as account_parent,c.name as headparent 
		FROM ".TB_PREF."chart_master a
		left join ".TB_PREF."chart_types b on a.account_type=b.id
		left join ".TB_PREF."chart_types c on b.parent=c.id
		where a.inactive=0 and a.account_code BETWEEN ".db_escape($acount_code)." and ".db_escape($acount_code2)." order by a.account_code asc";
	$result=db_query($sql, '');
	//return true;
	//$row = db_fetch_row($result);
	//return array($row[0],$row[1]);
	return $result;
}

function n_account_from_to($acount_code,$acount_code2)
{
	$sql = "SELECT count(a.account_code) as nrow
		FROM ".TB_PREF."chart_master a
		where a.inactive=0 and a.account_code BETWEEN ".db_escape($acount_code)." and ".db_escape($acount_code2)." order by a.account_code asc";
	$result=db_query($sql, '');
	//return true;
	$row = db_fetch_row($result);
	return $row[0];
	//return $result;
}


function get_parent($acount_code)
{
	$sql = "SELECT c.id as account_parent,c.name as headparent 
		FROM  ".TB_PREF."chart_types b 
		left join ".TB_PREF."chart_types c on b.parent=c.id
		where b.id=".db_escape($acount_code)." ";
	$result=db_query($sql, '');
	//return true;
	$row = db_fetch_row($result);
	return array($row[0],$row[1]);
	//return $result;
}

function gl_void($trans_type, $trans_no,$msg="delete")
{
	// guess tax register if not set
	$sql = "INSERT INTO ".TB_PREF."voided 
		(type, id, date_, memo_)
		VALUES (".db_escape($trans_type)."," . db_escape($trans_no).",'"
				.date('Y-m-d')."',".db_escape($msg).")";

	db_query($sql, "Cannot save trans tax details");

}

function get_total_trans($type, $trans_no)
{
	$sql = "SELECT SUM(a.amount)
		FROM ".TB_PREF."gl_trans a
		left join ".TB_PREF."voided b on a.type=b.type and a.type_no=b.id
		WHERE a.type=".db_escape($type)." and b.id is null and a.amount>0"
			." AND a.type_no=".db_escape($trans_no);

	$result = db_query($sql, "query for gl trans value");

	$row = db_fetch_row($result);
	return $row[0];
}
